unit Unit1;

{$MODE Delphi}

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, Comobj;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function kopioi_alkaen(source: string; alkaen: integer): string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const virhe = 'Hakua ei voitu suorittaa!';
var
  Form1: TForm1;
  httpreq: variant;
  pysayta: boolean;

implementation

{$R *.lfm}

function TForm1.kopioi_alkaen(source: string; alkaen: integer): string;
begin
 result:=copy(source, alkaen, length(source)-alkaen+1);
end;

function korjaa_UTF8(body: string): string;
var i: integer;
 skipnext: boolean;
begin
 result:='';
 if length(body)<1 then exit;
 skipnext:=false;
 for i:=1 to length(body)-1 do
 begin
  if skipnext=true then begin skipnext:=false; continue; end;
  if body[i]<>#194 then result:=result+body[i] else
  begin
   result:=result+utf8encode(body[i+1]);
   skipnext:=true;
  end;
 end;
 result:=result+body[length(body)];
end;

function xmlhttpget(fileURL: string): string;
var
  StartedTime, aika: DWord;
  URL: Olevariant;
  ar: array of byte;
  body: string;
begin
 result:='';
 aika:=20000;
 URL:=fileURL;
 StartedTime:=GetTickCount;
 try
  httpreq.open('GET', URL, true);
  httpreq.setRequestHeader('Content-Type', 'text/xml');
  httpreq.send();
  while (httpreq.readystate<>4) and (GetTickCount<startedtime+aika) and (pysayta=false) do
   begin application.processmessages; sleep(10); end;
  if (GetTickCount>=startedtime+aika) or (pysayta=true) then
  begin
   httpreq.abort;
   exit;
  end;
  if ((httpreq.status=200) or (httpreq.status=0)) and (httpreq.responsetext<>'') then
  begin
   ar:=httpreq.responsebody;
   if length(ar)>0 then
   begin
    SetString(body, PAnsiChar(@ar[0]), length(ar));
    if ansipos('somt', ansilowercase(fileURL))>0 then
    begin
     if ansipos(#194, body)>0 then body:=korjaa_UTF8(body); // miksi tarvitaan?
     result:=UTF8Decode(body);
    end;
    result:=body;
   end;
  end;
 except; httpreq.abort; end;
end;

function palautaid(s: string): string;
var p: integer;
begin
 result:=s;
 p:=ansipos('categories/', s);
 if p>0 then
 begin
  result:=form1.kopioi_alkaen(s, p+11);
 end;
end;

function nocache: string;
begin
 result:=inttostr(random(100000));
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 s, s2, item: string;
 i, j, k, paikka, laskuri: integer;
 itemit, itemit2, itemit3: array of array[1..2] of string;
begin
 memo1.text:='';
 pysayta:=false;
 button2.enabled:=false;
 setlength(itemit,0);
 s:=xmlhttpget('http://api.huuto.net/somt/0.9/categories?nocache='+nocache);
 if s='' then
 begin
  showmessage(virhe);
  exit;
 end;
 laskuri:=0;
 i:=ansipos('<id>', ansilowercase(s));
 while i>0 do
 begin
  s:=kopioi_alkaen(s, i+4);
  i:=ansipos('</id>', ansilowercase(s));
  item:=copy(s, 1, i-1);
  s:=kopioi_alkaen(s, i+5);
  i:=ansipos('<title>', ansilowercase(s));
  s:=kopioi_alkaen(s, i+7);
  i:=ansipos('</title>', ansilowercase(s));
  s2:=copy(s, 1, i-1);
  s2:=stringreplace(s2, '<![cdata[', '', [rfreplaceall, rfignorecase]);
  s2:=stringreplace(s2, ']]>', '', [rfreplaceall, rfignorecase]);
  s:=kopioi_alkaen(s, i+8);
  i:=ansipos('<id>', ansilowercase(s));
  paikka:=ansipos('categories/', item);
  if (paikka>0) and (item[length(item)]<>'/') then
  begin
   setlength(itemit, length(itemit)+1);
   itemit[laskuri,1]:=item;
   itemit[laskuri,2]:=s2;
   laskuri:=laskuri+1;
  end;
 end;
 for j:=0 to length(itemit)-1 do
 begin
  if pysayta=true then exit;
  memo1.Lines.add('m'+palautaid(itemit[j,1])+'='+itemit[j,2]);
  setlength(itemit2,0);
  s:=xmlhttpget(itemit[j,1]+'/subcategories?nocache='+nocache);
  if s='' then
  begin
   showmessage(virhe);
   exit;
  end;
  laskuri:=0;
  i:=ansipos('<id>', ansilowercase(s));
  while i>0 do
  begin
   s:=kopioi_alkaen(s, i+4);
   i:=ansipos('</id>', ansilowercase(s));
   item:=copy(s, 1, i-1);
   s:=kopioi_alkaen(s, i+5);
   i:=ansipos('<title>', ansilowercase(s));
   s:=kopioi_alkaen(s, i+7);
   i:=ansipos('</title>', ansilowercase(s));
   s2:=copy(s, 1, i-1);
   s2:=stringreplace(s2, '<![cdata[', '', [rfreplaceall, rfignorecase]);
   s2:=stringreplace(s2, ']]>', '', [rfreplaceall, rfignorecase]);
   s:=kopioi_alkaen(s, i+8);
   i:=ansipos('<id>', ansilowercase(s));
   paikka:=ansipos('categories/', item);
   if (paikka>0) and (item<>itemit[j,1]) then
   begin
    setlength(itemit2, length(itemit2)+1);
    itemit2[laskuri,1]:=item;
    itemit2[laskuri,2]:=s2;
    laskuri:=laskuri+1;
   end;
  end;
  for k:=0 to length(itemit2)-1 do
  begin
   if pysayta=true then exit;
   memo1.Lines.add('s'+palautaid(itemit2[k,1])+'='+itemit2[k,2]);
   setlength(itemit3,0);
   s:=xmlhttpget(itemit2[k,1]+'/subcategories?nocache='+nocache);
   if s='' then
   begin
    showmessage(virhe);
    exit;
   end;
   laskuri:=0;
   i:=ansipos('<id>', ansilowercase(s));
   while i>0 do
   begin
    s:=kopioi_alkaen(s, i+4);
    i:=ansipos('</id>', ansilowercase(s));
    item:=copy(s, 1, i-1);
    s:=kopioi_alkaen(s, i+5);
    i:=ansipos('<title>', ansilowercase(s));
    s:=kopioi_alkaen(s, i+7);
    i:=ansipos('</title>', ansilowercase(s));
    s2:=copy(s, 1, i-1);
    s2:=stringreplace(s2, '<![cdata[', '', [rfreplaceall, rfignorecase]);
    s2:=stringreplace(s2, ']]>', '', [rfreplaceall, rfignorecase]);
    s:=kopioi_alkaen(s, i+8);
    i:=ansipos('<id>', ansilowercase(s));
    paikka:=ansipos('categories/', item);
    if (paikka>0) and (item<>itemit2[k,1]) then
    begin
     setlength(itemit3, length(itemit3)+1);
     item:=palautaid(item);
     itemit3[laskuri,1]:=item;
     itemit3[laskuri,2]:=s2;
     memo1.Lines.add('c'+item+'='+s2);
     laskuri:=laskuri+1;
    end;
   end;
  end;
 end;
 showmessage('Ok');
 button2.enabled:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if savedialog1.execute then memo1.Lines.SaveToFile(savedialog1.filename);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 pysayta:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 httpreq:=createoleobject('MSXML2.XMLHTTP.6.0');
 randomize;
end;

end.
